#include "CollisionGame.h"
#include "Entity.h"
#include <sstream>


// Singleton pattern
CollisionGame* CollisionGame::instance = 0;

CollisionGame* CollisionGame::Instance() {
	if(instance == 0) {
		instance = new CollisionGame();
	}
	return instance;
}

void CollisionGame::Update(float dt) {

	switch(state) {
		case GS_INGAME:
		
			
		break;
		case GS_GAMEOVER:

		break;
	}
}

// Render everything in the game!
void CollisionGame::Render() {
	// Clear bg
	GFX::Instance()->GFXclearTo(Color(0,0,0));
	
	GFX::Instance()->GFXline(0, 0, 0, worldSize.y, Color(0,0,1.0f,0.5f));
	GFX::Instance()->GFXline(0, worldSize.y, worldSize.x, worldSize.y, Color(0,0,1.0f,0.5f));
	GFX::Instance()->GFXline(0, 0, worldSize.x, 0, Color(0,0,1.0f,0.5f));
	GFX::Instance()->GFXline(worldSize.x, 0, worldSize.x, worldSize.y, Color(0,0,1.0f,0.5f));
	if(test1) {
		gfx->GFXtext("HEY WE GOT INIT!", 500, 500, Color(255,255,255), Color(0,0,0));
	}
}

//TODO: Give a enemy def (enum) use that
Entity* CollisionGame::AddEntity(Entity *ent) {
	//CollisionManager::AddCollider(ent);
	//RenderManager::AddRenderer(ent);
	//CORE
	core->AddRenderer(ent);
	core->AddCollider(ent);
	entities.push_back(ent);
	return ent;
}

// Start a new game!
// Clears the grid and the terrain, then generates terrain (based on my arbitrary hardcoded values)
CollisionGame::CollisionGame() {
	core = Core::Instance();
	worldSize = Vec2(10000, 10000);
	state = GS_INGAME;
	Vec2 verts[3] = {Vec2(-50, -50), Vec2(0,-50), Vec2(100, 100)};

	/*Entity * yo = AddEntity(new Entity(3, Vec2(900, 900), verts, Color(255,255,255)));
	yo->isStatic = true;
	yo->dir = Vec2(0,0);
	Vec2 verts2[4] = {Vec2(-100, -50), Vec2(100,-50), Vec2(100, 50), Vec2(-100, 50)};

	core->tracking = AddEntity(new Entity(4, Vec2(800, 700), verts2, Color(200, 200, 200)));
	yo = (Entity *) core->tracking;
	yo->isStatic = true;
	yo->dir = Vec2(0,0);*/
	Vec2 *vert;
	for(int i = 0; i < 1000; i++) {
		int nverts = 3 + rand() % 3;
		vert = new Vec2[nverts];
		float size = (float)10 + (rand() % 100);
		//float size = 100;
		if(nverts == 3) {
			vert[0] = Vec2(-size, 0);
			vert[1] = Vec2(0, -size);
			vert[2] = Vec2(size, 0);
		}
		else if(nverts == 4){
			vert[0] = Vec2(-size, -size);
			vert[1] = Vec2(size, -size);
			vert[2] = Vec2(size, size);
			vert[3] = Vec2(-size, size);
		}
		else {
			vert[0] = Vec2(-size, 0);
			vert[1] = Vec2(0, -size);
			vert[2] = Vec2(size, 0);
			vert[3] = Vec2(size / 2.0f, size);
			vert[4] = Vec2(-size / 2.0f, size);
		}
		Color coll = Color(1 , 1, 0);
		Vec2 loc = Vec2((float)(rand() % (int)worldSize.x),float( rand() % (int)worldSize.y));
		//Vec2 loc = Vec2(2287,100);
		//Vec2 vertls[] = {Vec2(-10, 0), Vec2(0, -10), Vec2(10, 0)};
		//Entity *yo = AddEntity(new Entity(nverts, loc, vertls , coll));
		Entity *yo = AddEntity(new Entity(nverts, loc, vert , coll));
		yo->isStatic = false;
		yo->isTrigger = false;
		delete []vert;
		vert = 0;
	}
	//Core:AddCollider(new PolyCollider(4, Vec2(300, 200), verts2));
}

// Helper function that translates the enum dir into a vector.
Vec2 CollisionGame::DirToVec2(Direction dir) {

	Vec2 vTarget = Vec2(0, 0);

	switch(dir) {
	case DIR_UPLEFT:
		vTarget = Vec2(-1, -1);
		break;
	case DIR_UP:
		vTarget = Vec2(0, -1);
		break;
	case DIR_UPRIGHT:
		vTarget = Vec2(1, -1);
		break;
	case DIR_LEFT:
		vTarget = Vec2(-1, 0);
		break;
	case DIR_NONE:
		vTarget = Vec2(0, 0);
		break;
	case DIR_RIGHT:
		vTarget = Vec2(1, 0);
		break;
	case DIR_DOWNLEFT:
		vTarget = Vec2(-1, 1);
		break;
	case DIR_DOWN:
		vTarget = Vec2(0, 1);
		break;
	case DIR_DOWNRIGHT:
		vTarget = Vec2(1, 1);
		break;
	}

	return vTarget;
}

Direction CollisionGame::Vec2ToDir(Vec2 vec) {
	if(vec.x > 0) {
		if(vec.y > 0)	return DIR_DOWNRIGHT;
		if(vec.y == 0)	return DIR_RIGHT;
		else			return DIR_UPRIGHT;
	}
	else if(vec.x == 0) {
		if(vec.y > 0)	return DIR_DOWN;
		if(vec.y == 0)	return DIR_NONE;
		else			return DIR_UP;
	}
	else {
		if(vec.y > 0)	return DIR_DOWNLEFT;
		if(vec.y == 0)	return DIR_LEFT;
		else			return DIR_UPLEFT;
	}

}