#pragma once
#include "Core.h"
#include <vector>
#include "Text.h"

class Entity;

// Our game class, which is the main manager of all things game-related.
class CollisionGame : public Renderer {
public:
	static CollisionGame* Instance();
	virtual void Init(){};

	// Public vars
	GameState state;

	// Helper Functions
	static Vec2 DirToVec2(Direction dir);
	static Direction Vec2ToDir(Vec2 vec);

	Entity *AddEntity(Entity *entity);

	// Logic/Render
	void Update(float dt);
	void Render();
	void Destroy(){ };

	bool test1;
	PolyCollider *c1;
	PolyCollider *c2;
	std::vector<Entity *> entities;
	Vec2 worldSize;
	~CollisionGame(){ }
protected:
	CollisionGame();
private:
	// Singleton instance
	static CollisionGame* instance;
};
extern Core* core;