#include <assert.h>
#include "Vec2.h"
#include "Core.h"
#include "Entity.h"
#include "GFX.h"

Vec2 Entity::GetPos() {
	return center;
}

void Entity::SetPos(Vec2 newpos) {
	pos = newpos;
	PolyCollider::MoveTo(newpos);
}	

void Entity::Update(float dt) {
	if(!game) game = CollisionGame::Instance();
	if(!game) return;
	SetPos(center + dir*500 * dt);
	if(dir.x < 0 && center.x <= 0) dir.x = -dir.x;
	if(dir.y < 0 && center.y <= 0) dir.y = -dir.y;
	if(dir.x > 0 && center.x >= game->worldSize.x) dir.x = -dir.x;
	if(dir.y > 0 && center.y >= game->worldSize.y) dir.y = -dir.y;
}

void Entity::Render() {
	//GFX *gfx = GFX::Instance();
	//gfx->GFXline(pos.x-50, pos.y-50, pos.x+50, pos.y+50, col);
	//gfx->GFXline(pos.x+50, pos.y-50, pos.x-50, pos.y+50, col);
	
}

void Entity::CollidedWith(Collider *other) {
	//this->dir.x = -dir.x;
	//this->dir.y = -dir.y;

}
