#include "Text.h"
//#include <FTGL/ftgl.h>
#include "Core.h"
#include "SDL_opengl.h"

Text::Text(const char text[], Vec2 pos, int size, Color col) { 
	strncpy_s(this->text, 256, text, _TRUNCATE); 	
	font = new FTTextureFont("morgue.ttf");

	if(font->Error())
	{
		fprintf(stderr, " Could not load font!\n");
		return;
	}
	font->FaceSize(size);
	//font->FaceSize(size);
	font->Depth(10);
	font->Outset(0, 3);
	font->CharMap(ft_encoding_unicode);
	this->pos = pos;
	this->col = col;
}

void Text::SetText(const char *str) {
	strncpy_s(this->text, 256, str, _TRUNCATE);
}

void Text::Render() {
	float czoom = Core::Instance()->cameraZoom;
	Vec2 ccenter = Core::Instance()->cameraCenter;
	glColor4f(1,1,1,1);
	glPushMatrix();
	/*
	// Remove Camera offset (Center is negative)
	glTranslatef((ccenter.x), ((ccenter.y )), 1);
	
	// Remove Camera Zoom
	glScalef(1.0f / czoom, 1.0f /czoom, 1);
	glTranslatef(pos.x, pos.y, 1);
	glScalef(1, -1, 0);
	if(font)
	font->Render(text);*/
	glLoadIdentity();
	glTranslatef(pos.x, pos.y, 1);
	glScalef(1, -1, 0);
	if(font)
		font->Render(text);
	glPopMatrix();
}